<asset>
    <style>
        td.assetId {
            text-decoration: underline;
            cursor: pointer;
        }
        #asset-search-items {
            margin-top: 35px;
            margin-bottom: 12px;
            margin-right: 25px;
        }
        #asset-search-items label {
            margin-right: 10px;
        }
        #individual {
            border-radius: 5px;
            margin: -8px 30px -5px 20px !important;
        }
        input[type='radio'] {
            width: 20px !important;
        }
        .all-checkbox {
            visibility: visible !important;
        }
        .DTFC_LeftBodyLiner .all-checkbox {
            visibility: hidden !important;
        }
        th.select-checkbox:before {
            display: block;
            position: absolute;
            top: 30px;
            /*left: 50%;*/
            width: 12px;
            height: 12px;
            box-sizing: border-box;
            content: ' ';
            margin-top: -6px;
            margin-left: -6px;
            border: 1px solid black;
            border-radius: 3px;
        }
        th.all-checkbox.checked:after {
            content: '\2714';
            margin-top: -11px;
            margin-left: -4px;
            text-align: center;
            text-shadow: 1px 1px #b0bed9, -1px -1px #b0bed9, 1px -1px #b0bed9, -1px 1px #b0bed9;
        }
        #search-value {
            margin-left: 10px;
            margin-top: 3px;
            width: 120px;
        }
    </style>
    <div id="asset-search-items" class="hide">
        <select id="search-type"/>
        <input type="text" id="search-value"/>
        <a id="individual" class="dt-button buttons-create btn btn-nc" onclick="{clickIndividual}">個別検索</a>
        <label for="expired">利用期限: </label>
        <select id="expired"/>
    </div>
    <data/>
    <script>
        export default {
            clickIndividual() {
                localStorage.setItem('assetInitFlg', 'false')
                localStorage.removeItem('clickSearch')
                $("#asset_datatables").dataTable().api().ajax.reload()
            },
            onBeforeMount(props, state) {
                this.scrutiny = props.scrutiny
                this.logoutModal = props.logoutModal
                this.service = new AssetService()
                this.mapService = new MapService()
                this.orderService = new OrderService()
                this.codeService = new CodeService()
                localStorage.setItem('assetInitFlg', 'true')
            },
            async onMounted(props, states) {
                const response = await this.service.searchValidGroupId(UserInfo.getInstance().email)
                if (response.status == 'NG' || response.message) {
                    toastr.error(response.message)
                    return
                }
                this.validAssets = response.data
                clearErrorMessage()
                RiotUtil.next("data", {
                    logoutModal: this.logoutModal,
                    scrutiny: this.scrutiny,
                    mapService: this.mapService,
                    orderService: this.orderService,
                    codeService: this.codeService,
                    initFlg: this.initFlg,
                    validAssets: this.validAssets,
                    title: "端末管理",
                    name: 'asset',
                    items: ["端末ID", "端末名", "パスワード","利用者名", "利用開始日", "利用終了日","連絡用メール",'発送先名',"電話番号", "住所", "備考", "注文番号", "機種",
                        "IMEI", "IMSI", "SIMID", "グループID", "アラート種類", "アラートメール", "バージョン", "発信間隔パターン", "個別メッセージ", "発信間隔タイマー時刻",
                    "端末状態", "所有者メール", "削除予定日", '更新日時', '最終ログイン時刻'],
                    service: this.service,
                    disabledColumns: [2,14,28,29],
                    showAllCheckbox: true,
                    leftButtons: [{
                        label: '連続登録',
                        onclick: function () {
                            riot.unmount('commonmodal', {}, 'assetcontinuous')
                            const assetContinuousModal = riot.mount('commonmodal', {
                               assetService: new AssetService(),
                               codeService: new CodeService()
                           }, 'assetcontinuous')[0]
                           assetContinuousModal.show()
                       }
                    },{
                        label: '検索',
                        onclick: function () {
                            localStorage.setItem('assetInitFlg', 'false')
                            localStorage.setItem('clickSearch', 'true')
                            $("#asset_datatables").dataTable().api().ajax.reload()
                        }
                    }],
                    ajax: async function (handler) {
                        const initFlg = localStorage.getItem('assetInitFlg')
                        const sleep = function () {
                            return new Promise(function(resolve, reject) {
                                setTimeout(() => {
                                        resolve()
                                    });
                                }, 1)

                            }
                        await sleep()
                        if (initFlg == 'true') {
                            return handler([])
                        }

                        const searchValue = $('#search-value').val()
                        const searchType = $('#search-type').val()
                        const email = UserInfo.getInstance().getEmail()
                        const params = {
                            email : '',
                            searchValue: '',
                            searchType
                        }

                        const clickSearch = localStorage.getItem('clickSearch')
                        let response
                        if (searchType && searchValue && clickSearch != 'true') {
                            params.searchValue = searchValue
                        } else {
                            params.email = email
                            localStorage.removeItem('clickSearch')
                        }
                        response = await this.service.search(params)
                        if (response.status != "OK" || !response.data || response.data.length < 1) {
                            return handler([])
                        }
                        let jsons = []
                        response.data.forEach(data => {
                            const json = {
                                assetId: this.scrutiny(data.assetId),
                                assetName: data.assetName ? trim(data.assetName) : '',
                                password: this.scrutiny(data.password),
                                groupId: this.scrutiny(data.groupId),
                                kindType: this.scrutiny(data.kindType),
                                imei: this.scrutiny(data.imei),
                                imsi: this.scrutiny(data.imsi),
                                userName: this.scrutiny(data.userName),
                                start: this.scrutiny(data.start),
                                end: this.scrutiny(data.end),
                                memo: this.scrutiny(data.memo),
                                alertType: this.scrutiny(data.alertType),
                                alertEmail: this.scrutiny(data.alertEmail),
                                contactEmail: this.scrutiny(data.contactEmail),
                                shipName:  this.scrutiny(data.shipName),
                                contactTel: this.scrutiny(data.contactTel),
                                contactAddress: this.scrutiny(data.contactAddress),
                                orderNo: this.scrutiny(data.orderNo),
                                pro: this.scrutiny(data.pro),
                                sendOpt: this.scrutiny(data.sendOpt),
                                message: this.scrutiny(data.message),
                                sendTimeOut: this.scrutiny(data.sendTimeOut),
                                simId: this.scrutiny(data.simId),
                                status: this.scrutiny(data.status),
                                email: this.scrutiny(data.email),
                                unixTime: data.unixTime,
                                updatedAt: data.updatedAt ? data.updatedAt : '',
                                lastLoginAt: data.lastLoginAt ? data.lastLoginAt : '',
                                rowId: data.rowId ? data.rowId : Math.random()
                            }
                            jsons.push(json)
                        })
                        if (searchType && searchValue && clickSearch != 'true') {
                            handler(jsons)
                            return
                        }
                        const value = $('#expired').val()

                        // 1ヶ月以上切れを除外
                        if (!value) {
                            jsons = jsons.filter(function (json) {
                                const end = moment(json.end)
                                const diff = end.diff(moment(), 'months')
                                return diff > -1
                            })
                            handler(jsons)
                            return
                        }

                        // 条件なし
                        if (value == -2) {
                            handler(jsons)
                            return
                        }
                        // 利用開始日なし
                        if (value == -1) {
                            jsons = jsons.filter(function (json) {
                                return !json.start
                            })
                            handler(jsons)
                            return
                        }
                        if (value == 2) {
                            jsons = jsons.filter(function (json) {
                                return json.status == 9
                            })
                            handler(jsons)
                            return
                        }
                        jsons = jsons.filter(function (json){
                            const end = moment(json.end)
                            if (value == 0) {
                                // 1日でも過ぎている
                                const diff = moment().diff(end, 'days')
                                return diff > 0 && (!json.assetName || json.assetName.indexOf('解約') < 0)
                            } else if (value == 1) {
                                // Nヶ月
                                end.add(1, 'days')
                                const diff = moment().diff(end, 'months')
                                return diff >= value && (!json.assetName || json.assetName.indexOf('解約') < 0)
                            } else if (value == 3) {
                                // 期限残り
                                const diff = end.diff(moment(), 'months')
                                // 1ヶ月以上残り
                                return diff >= 1
                            } else if (value == 4) {
                                return json.unixTime
                            }
                        })
                        handler(jsons)
                    },
                    initComplete: function() {
                        $('#asset-search-items').removeClass('hide')
                        $('admincontent #search-menu').prepend($('#asset-search-items'))

                        const data =  [
                            {id: '', text: ''}, {id: -2, text: '全て'}, {id: -1, text: '利用開始日なし'},
                            {id: 0, text: '利用期限切れ'}, {id: 1, text: '1ヶ月以上切れ'}, {id: 2, text: '端末解約済み'},
                            {id: 3, text: '1ヶ月以上残り'}, {id: 4, text: '削除予定あり'}]
                        $("#expired").addClass('select').css('width', '180px').select2({data})

                        const searchType =  [
                            {id: 1, text: '端末ID'}, {id: 2, text: '注文番号'},
                            {id: 3, text: 'メール'},{id: 4, text: '利用者名'}, {id: 5, text: 'IMEI'},{id: 6, text: 'SIMID'},]
                        $("#search-type").addClass('select').css('width', '120px').val(1).select2({data: searchType})
                    },
                    draw: function() {
                        $('td.assetId').off('click')
                        $('td.assetId').on('click', {mapService: this.mapService, scrutiny: this.scrutiny}, function (e) {
                            const assetId = $(this).parent().find('.assetId').text()
                            riot.unmount('commonmodal', {}, 'assetmodal')
                            const assetModal = riot.mount('commonmodal',{
                                assetId: assetId,
                                mapService: e.data.mapService,
                                scrutiny: e.data.scrutiny,
                            }, 'assetmodal')[0]
                            assetModal.show()
                        })

                        $('.DTFC_LeftHeadWrapper .all-checkbox').off('click')
                        $('.DTFC_LeftHeadWrapper .all-checkbox').on('click', function () {
                            const checked = $(this).hasClass('checked')
                            if (checked) {
                                $('#asset_datatables').dataTable().api().rows().deselect()
                                $(this).removeClass('checked')
                            } else {
                                $('#asset_datatables').dataTable().api().rows().select()
                                $(this).addClass('checked')
                            }
                        })
                    },
                    preSubmit: function  (e, json, action, self) {

                        if (action == 'remove') return

                        const assetId = self.field('assetId')
                        if (!v8n().not.null().not.empty().test(assetId.get())) {
                            assetId.error('端末IDは必須です')
                        }

                        const password = self.field('password')
                        if (!v8n().not.null().not.empty().test(password.get())) {
                            password.error('パスワードは必須です')
                        }

                        const imei = self.field('imei')
                        if (!v8n().not.null().not.empty().test(imei.get())) {
                            imei.error('IMEIは必須です')
                        }

                        // グループIDは所有者以外で既に設定されている場合エラーとする
                        const groupId = self.field('groupId')
                        if (groupId.get()) {
                            const item = this.validAssets.find(item => {
                               return item.groupId == groupId.get()
                            })
                            if (item) {
                                groupId.error('このグループIDは既に使用されています')
                            }
                        }

                        const target = json.data[_.keys(json.data)[0]]

                        // unixtimeは3ヶ月以後の日付
                        let unixTime = self.field('unixTime').get()
                        if (unixTime) {
                            let utime = moment.unix(unixTime)
                            if (!utime.isValid()) {
                                utime = moment(unixTime)
                            }
                            utime = utime.hours(0).minutes(0).seconds(0)
                            const today = moment().hours(0).minutes(0).seconds(0)
                            const diff = utime.diff(today, 'days')
                            if (diff < 90) {
                                self.field('unixTime').error('3ヶ月以後を指定してください')
                            } else {
                                target.unixTime = utime.unix()
                            }
                        }

                        const assetName = self.field('assetName')
                        if (!v8n().not.null().not.empty().test(assetName.get())) {
                            target.assetName = " "
                        }

                        if (target.alertEmail) {
                            target.alertEmail = target.alertEmail.split('\n').join(',')
                        }

                        if (target.sendOpt) {
                            target.sendOpt = target.sendOpt.split('\n').join(',')
                        }

                        if (self.inError()) {
                            return false
                        }
                    },
                    addJSON: function (json) {
                        const alertTypeRender = function (data, type, row) {
                            if (!data) return ''
                            const alertTypes = Code.ALERT_TYPE.filter(code => {
                                return data.indexOf(code.value) > -1
                            })
                            const alerts = []
                            alertTypes.forEach(alertType => {
                                alerts.push(alertType.label)
                            })
                            return alerts.join(",")
                        }

                        json.columns.forEach(function (column) {
                            if (column.data == 'alertType') {
                                column.render = alertTypeRender
                            }
                            if (column.data == 'alertEmail') {
                                column.render = function (data, type, row) {
                                    if (data && data.indexOf(',') != -1) {
                                        data = data.split(',').join('<br>')
                                    }
                                    return data
                                }
                            }
                            if (column.data == 'message') {
                                column.render = function (data, type, row) {
                                    if (data && data.indexOf('\n') != -1) {
                                        data = data.split('\n').join('<br>')
                                    }
                                    return data
                                }
                            }
                            if (column.data == 'pro') {
                                column.render = function (data, type, row) {
                                    const code = Code.PRO.filter(code => {
                                        return code.value == data
                                    })[0]
                                    return code.label
                                }
                            }
                            if (column.data == 'status') {
                                column.render = function (data, type, row) {
                                    const code = Code.ASSET_STATUS.filter(code => {
                                        return code.value == data
                                    })[0]
                                    return code.label
                                }
                            }
                            if (column.data == 'unixTime') {
                                column.render = function (data, type, row) {
                                    if (!data) return  ''

                                    let utime = moment.unix(data)
                                    if (!utime.isValid()) {
                                        utime = moment(data)
                                    }
                                    return utime.format('YYYY-MM-DD')
                                }
                            }
                        })
                        return json
                    },
                    open: function (e, json, action, editor) {

                        if (action == 'edit') {
                            editor.field('assetId').disable()
                            editor.field('imei').disable()
                        } else {
                            editor.field('assetId').enable()
                            editor.field('imei').enable()
                            editor.field('email').set(UserInfo.getInstance().getEmail())
                        }

                        const alertEmail = editor.field('alertEmail').get()
                        if (alertEmail) {
                            editor.field('alertEmail').set(alertEmail.split(',').join('\n'))
                        }

                        const oldOrderNo = editor.field('orderNo').get()
                        localStorage.setItem('oldOrderNo', oldOrderNo)

                        const oldStart = editor.field('start').get()
                        localStorage.setItem('oldStart', oldStart)

                        const unixtime = editor.field('unixTime').get()
                        if (unixtime) {
                            let utime = moment.unix(unixtime)
                            if (!utime.isValid()) {
                                utime = moment(unixtime)
                            }
                            editor.field('unixTime').set(utime.format('YYYY-MM-DD'))
                        }

                        $("input:checkbox").css("width", "20px")
                        $('.DTE_Field_Name_updatedAt').hide()
                        $('.DTE_Field_Name_lastLoginAt').hide()
                    },
                    submitError: async function (e, json, data) {
                        if (!data || !data.message) return

                        const message = data.message
                        riot.unmount('commonmodal', {}, 'assetupdateerror')
                        const assetUpdateErrorModal = riot.mount('commonmodal',{
                            message
                        }, 'assetupdateerror')[0]
                        assetUpdateErrorModal.show()
                    },
                    submitSuccess: async function (e, json, data) {

                        const api = $('#asset_datatables').dataTable().api()

                        const index = api.data().toArray().findIndex(u => {return u.assetId == data.assetId})
                        const oldStart = localStorage.getItem('oldStart')
                        // 利用開始日を入力したら端末状態を使用中にする
                        const start = data.start
                        const status = data.status
                        if (start && start != oldStart && !status) {
                            const assetService = new AssetService()
                            const r = await assetService.get(data.assetId)
                            if (r.statusCode == 200) {
                                data.updatedAt = r.data[0].updatedAt
                                data.status = 1
                                await assetService.update(data)
                            }
                        }
                        localStorage.removeItem('oldStart')

                        let oldOrderNo = localStorage.getItem('oldOrderNo')
                        if (oldOrderNo == null || oldOrderNo == undefined) {
                            api.ajax.reload()
                            return
                        }

                        oldOrderNo = oldOrderNo.trim()
                        const orderNo = data.orderNo.trim()

                        if (!orderNo || orderNo == oldOrderNo) {
                            api.ajax.reload()
                            return
                        }
                        localStorage.removeItem('oldOrderNo')

                        const response = await this.orderService.get(orderNo)
                        if (response.statusCode != 200) {
                            toastr.error(response.message)
                            api.ajax.reload()
                            return
                        }
                        if (!response.data) {
                            toastr.warning('注文データが見つかりません。')
                            api.ajax.reload()
                            return
                        }
                        const order = response.data
                        const params = data
                        params.shipName = order.buyerName == order.shipName ? order.buyerName : `${order.buyerName}(${order.shipName})`
                        params.contactAddress = order.shipAddress
                        params.contactTel = order.shipPhone
                        params.kindType = order.planName
                        params.start = moment().format('YYYY-MM-DD')

                        const planName = order.planName
                        const codeResp = await this.codeService.get('plan')
                        if (codeResp.statusCode != 200) {
                            toastr.error(codeResp.message)
                            api.ajax.reload()
                            return
                        }
                        const code = codeResp.data.find(function (code) {
                            return code.key == planName
                        })
                        if (code) {
                            params.end = moment().add(code.value, 'days').format('YYYY-MM-DD')
                        }
                        if (params.end) {
                            e.currentTarget.edit(index,false).set('end',params.end)
                        }
                        e.currentTarget.edit(index,false).set('shipName',params.shipName)
                        e.currentTarget.edit(index,false).set('contactAddress',params.contactAddress)
                        e.currentTarget.edit(index,false).set('kindType',params.kindType)
                        e.currentTarget.edit(index,false).set('start',params.start)
                        e.currentTarget.edit(index,false).set('contactTel',params.contactTel).submit()

                        // 0: 準備完了, 1: 使用中, 2: 休止中, 9: 解約済み
                        // 準備完了を使用中にする
                        if (!data.status) {
                            e.currentTarget.edit(index,false).set('status', 1)
                        }

                        // e.currentTarget.edit(index,false).set(params).submit()

                        // self.opts.editor.edit(index, false).set(data).submit()

                        api.ajax.reload()
                    },
                    actionButtons: [{
                        text: "個別CSV出力",
                        func: async function (e, dt, editor, self) {
                            const data = dt.rows('.selected').data()
                            if (!data || data.length < 1) {
                                toastr.warning('アップロード対象のデータを選択してください')
                                return
                            }
                            const assetId = data.toArray().map(function(item) { return item.assetId })
                            const service = new AssetService()
                            const filePath = `${moment().format('YYYY/MM')}/asset/${UserInfo.getInstance().getEmail()}`
                            const fileName = `asset_${moment().format('YYYYMMDD_HHmmss')}.csv`
                            const result = await service.uploadCsv(filePath, fileName, assetId)
                            if (result.statusCode != 200) {
                                toastr.error(result.message)
                                return
                            }
                            // const s3Path = result.data
                            const url = `data.cloudgps.io/${filePath}/${fileName}`
                            riot.unmount('commonmodal', {}, 'assetmodal')
                            const assetS3Modal = riot.mount('commonmodal',{
                                url,
                            }, 'assets3modal')[0]
                            assetS3Modal.show()
                            toastr.success('CSVアップロード処理完了しました')
                        }
                    }, {
                        text: "全件CSV出力",
                        func: async function (e, dt, editor, self) {
                            const data = dt.data()
                            const assetId = data.toArray().map(function(item) { return item.assetId }).sort()
                            const service = new AssetService()
                            const filePath = `${moment().format('YYYY/MM')}/asset/${UserInfo.getInstance().getEmail()}`
                            const fileName = `asset_${moment().format('YYYYMMDD_HHmmss')}.csv`
                            service.uploadCsv(filePath, fileName, assetId).then((result) => {
                                if (result.statusCode != 200) {
                                    toastr.error(result.message)
                                }
                            })
                            // const s3Path = result.data
                            const url = `data.cloudgps.io/${filePath}/${fileName}`
                            riot.unmount('commonmodal', {}, 'assetmodal')
                            const assetS3Modal = riot.mount('commonmodal',{
                                url
                            }, 'assets3modal')[0]
                            assetS3Modal.show()
                            toastr.success('CSVアップロード処理完了しました')
                        }
                    }, {
                        text: "再開",
                        func: async function (e, dt, editor, self) {
                            let data = dt.rows('.selected').data()
                            if (!data || !data.length) {
                                toastr.warning('再開対象のデータを選択してください')
                                return
                            }
                            // 解約済みでない場合はスキップ
                            const skipTargets = []
                            data = data.filter(item => {
                                if (item.status != 9) {
                                    skipTargets.push(item)
                                }
                                return item.status == 9
                            })
                            // const simIds = data.toArray().map(function (item) {
                            //     return item.simId
                            // }).sort()

                            if (skipTargets.length) {
                                skipTargets.forEach(target => {
                                    toastr.warning(`端末ID: ${target.assetId}の再開処理をスキップします`)
                                })
                            }

                            if (!data.length) return

                            riot.unmount('commonmodal', {}, 'simmodal')
                            const simModal = riot.mount('commonmodal',{
                                data,
                                editor,
                                key: 'setToStandby'
                            }, 'simmodal')[0]
                            simModal.show()
                        }
                    }, {
                        text: "解約",
                        func: async function (e, dt, editor, self) {
                            let data = dt.rows('.selected').data()
                            if (!data || !data.length) {
                                toastr.warning('解約対象のデータを選択してください')
                                return
                            }
                            // 使用中 or 休止中でない場合はスキップ
                            const skipTargets = []
                            data = data.filter(item => {
                                if (item.status != 1 && item.status != 2) {
                                    skipTargets.push(item)
                                }
                                return item.status == 1 || item.status == 2
                            })
                            // const simIds = data.toArray().map(function (item) {
                            //     return item.simId
                            // }).sort()

                            if (skipTargets.length) {
                                skipTargets.forEach(target => {
                                    toastr.warning(`端末ID: ${target.assetId}の解約処理をスキップします`)
                                })
                            }

                            if (!data.length) return

                            riot.unmount('commonmodal', {}, 'simmodal')
                            const simModal = riot.mount('commonmodal',{
                                data,
                                editor,
                                key: 'suspend'
                            }, 'simmodal')[0]
                            simModal.show()
                        }
                    },{
                        text: "クーポンコード",
                        func: async function (e, dt, editor, self) {
                            let data = dt.rows('.selected').data()
                            if (!data || !data.length) {
                                toastr.warning('クーポンコード表示対象のデータを選択してください')
                                return
                            }
                            riot.unmount('commonmodal', {}, 'couponmodal')
                            const couponModal = riot.mount('commonmodal',{
                                data
                            }, 'couponmodal')[0]
                            couponModal.show()
                        }
                    },{
                        text: "個別移行",
                        func: async function (e, dt, editor, self) {
                            riot.unmount('commonmodal', {}, 'assetsingletransitionmodal')
                            const singleTransitionModal = riot.mount('commonmodal',{
                                service: new AssetService()
                            }, 'assetsingletransitionmodal')[0]
                            singleTransitionModal.show()
                        }
                    }]
                }, "datatables")
            }
        }

        function trim(data) {
            if (data == ' ') {
                return ''
            }
            return data
        }

        function clearErrorMessage() {
            $("#error-message").text('').addClass('hide')
        }
        function setErrorMessage(message) {
            $("#error-message").text(message).removeClass('hide')
        }

    </script>
</asset>
